void reset_to_default_response(GtkDialog *dialog, gint       arg1, gpointer   user_data)  {

	if (arg1 == GTK_RESPONSE_OK) {
          gconf_client_recursive_unset    (client, "/apps/compiz", GCONF_UNSET_INCLUDING_SCHEMA_NAMES, NULL);
	  sleep(1);
	}

	redraw_groups(icon_groups);
     gtk_widget_destroy(GTK_WIDGET(dialog));

   return;
}


GtkWidget *dbus_dialog;
void dbus_dialog_ignore() {
 gtk_widget_destroy(dbus_dialog);
}

void dbus_dialog_activate() {
    activate_plugin("dbus");
    gtk_widget_destroy(dbus_dialog);
     if (!init_dbus ())	{
       printf("Still Could not activate dbus\n");//dialog_dbus_error_again();
     } 
}

void dialog_dbus_error() {

  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *button1;
  GtkWidget * image;

  dbus_dialog = gtk_dialog_new ();
  gtk_window_set_modal (GTK_WINDOW(dbus_dialog), TRUE);
  //gdk_pointer_grab (dialog1->window, TRUE, GDK_BUTTON_PRESS_MASK, NULL, NULL, GDK_CURRENT_TIME);
  gtk_window_set_default_size (GTK_WINDOW (dbus_dialog), 400, 125);
  gtk_window_set_title (GTK_WINDOW (dbus_dialog), _("Dbus Error"));
  gtk_window_set_type_hint (GTK_WINDOW (dbus_dialog), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dbus_dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  GtkWidget * hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox, FALSE, FALSE, 0);

  image = create_pixmap (dbus_dialog, "warning.png");
  gtk_misc_set_padding (GTK_MISC (image), 10, 10);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);


  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vbox1, FALSE, FALSE, 0);
  label1 = gtk_label_new (_("<b><span size=\"large\">Dbus Failed to load</span></b>"));
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label1), 0, 10);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);

  gboolean compiz_running = FALSE;
  if (compiz_is_running() == FALSE) {
    compiz_running = FALSE;
    label2 = gtk_label_new (_("Compiz is not running. The dbus plugin cannot be activated unless compiz is running"));
  } else {
    compiz_running = TRUE;
    label2 = gtk_label_new (_("The dbus plugin is appears not to be active. Some options maybe missing without the dbus plugin. \n\n <b>Would you like to enable it?</b>"));
  }

  gtk_label_set_use_markup (GTK_LABEL (label2), TRUE);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);

  dialog_action_area1 = GTK_DIALOG (dbus_dialog)->action_area;
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 =   button1 = new_label_button(0, "Ignore", (GFunc *) dbus_dialog_ignore, "gtk-go-forward");
 // gtk_dialog_add_action_widget (GTK_DIALOG (dbus_dialog), cancelbutton1, GTK_RESPONSE_CANCEL);
  gtk_box_pack_start (GTK_BOX(dialog_action_area1), cancelbutton1, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

 if (compiz_running == TRUE) {
  button1 = new_label_button(0, "Yes Activate", (GFunc *) dbus_dialog_activate, "gtk-execute");
 // gtk_dialog_add_action_widget (GTK_DIALOG (dbus_dialog), button1, GTK_RESPONSE_OK);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button1, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
 }

  //g_signal_connect (GTK_DIALOG(dialog1), "response", G_CALLBACK (reset_to_default_response), NULL);

  gtk_widget_show_all(dbus_dialog);
} 


void reset_to_default() {

  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;
  GtkWidget * image;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_modal (GTK_WINDOW(dialog1), TRUE);
  //gdk_pointer_grab (dialog1->window, TRUE, GDK_BUTTON_PRESS_MASK, NULL, NULL, GDK_CURRENT_TIME);
  gtk_window_set_default_size (GTK_WINDOW (dialog1), 400, 125);
  gtk_window_set_title (GTK_WINDOW (dialog1), _("Reset"));
  gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  GtkWidget * hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox, FALSE, FALSE, 0);

  image = create_pixmap (dialog1, "question.png");
  gtk_misc_set_padding (GTK_MISC (image), 10, 10);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);


  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vbox1, FALSE, FALSE, 0);
  label1 = gtk_label_new (_("<b><span size=\"large\">Really Reset?</span></b>"));
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label1), 0, 10);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);

  label2 = gtk_label_new (_("This will revert any options you've changed to their default value. "));
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

  g_signal_connect (GTK_DIALOG(dialog1), "response", G_CALLBACK (reset_to_default_response), NULL);

  gtk_widget_show_all(dialog1);
} 
